#ifndef __connection_h
#define __connection_h

#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>

#include <pthread.h>


#define INBUF_SIZE 1024

class Player;
class Global;

class Connection {
	public:
		Connection();
		Connection(int ifd);
		Connection(Global *pGlobal);
		~Connection();
		bool SetFlag(long lp_Flag);
		bool ClearFlag(long lp_Flag);
		bool GetFlag(long lp_Flag);
		int SetAccept(int port);
		bool IsReadable();
		bool IsWritable();
		bool WaitForRead();
		bool WriteLine(char *fmt, ...);
		bool Write(char *fmt, ...);
		char *ReadLine();
		void SetGlobal(Global *ppGlobal);
		void SetFd(int ifd);
		int GetFd();
		void StartThread();
		void Close();
		void Hangup();
		void StartFunction();
		Connection *GetNextObj();

	public:
		int fd;
		struct sockaddr_in in_addr;

		char inbuf[1024]; // input buffer
				  // please note - this is also tacky
				  // and for anything more than sample
				  // code we would have a FIFO

	private:
		void CloseFd(void);
	private:
		int id;
		long l_Flags;
		pthread_t thread_handle;
		Connection *pNext;
		Connection *pPrev;
		Player *pPlayer;
		Global *pGlobal;
};

#endif
